
#  Clock.py  Copyright (c) Kari Laitinen

#  http://www.naturalprogramming.com

#  2006-05-10  File created.
#  2022-12-18  Converted to Python 3.

from threading import Thread
from time import sleep
from datetime import datetime

class ThreadToShowSeconds ( Thread ) :

   def __init__( self ) :

      Thread.__init__( self ) 
      self.must_show_seconds  =  True

   def stop_this_thread( self ) :

      self.must_show_seconds  =  False


   def run( self ) :

      while  self.must_show_seconds  ==  True  :

         date_and_time_now  =  datetime.today()
   
         seconds_of_current_time  =  date_and_time_now.second
   
         if  seconds_of_current_time  %  20  ==  0  :
   
            print( "" ) # start new line
   
         print( " %02d"  %  seconds_of_current_time )

         sleep( 1.000 )  # Delay of one second.




class ThreadToShowFullTimeInfo ( Thread ) :

   def __init__( self ) :

      Thread.__init__( self ) 
      self.must_show_full_time_info  =  True

   def stop_this_thread( self ) :

      self.must_show_full_time_info  =  False


   def run( self ) :

      date_and_time_now  =  datetime.today()

      seconds_to_first_time_printing  =  60  -  date_and_time_now.second

      while  seconds_to_first_time_printing  >  0  and  \
             self.must_show_full_time_info  ==  True  :

         sleep( 1.000 )
         seconds_to_first_time_printing  -=  1


      while  self.must_show_full_time_info  ==  True  :

         date_and_time_now  =  datetime.today()

         print( "\n\n %s \n"  %  date_and_time_now.time().isoformat() )

         seconds_to_next_time_printing  =  60

         while  seconds_to_next_time_printing  >  0  and  \
                self.must_show_full_time_info  ==  True  :
   
            sleep( 1.000 )
            seconds_to_next_time_printing  -=  1

         #  The above while loop creates a 60-second delay
         #  by creating 60 1-second delays. It would be 
         #  easier to create the delay with a statement like
         #      time.sleep( 60.000 )  # Delay of 60 seconds.
         #  However, when the delay is created in 1-second
         #  subdelays, it it possible to terminate the
         #  thread within a second.

         #  I could not find a standard mechanism for
         #  interrupting a time.sleep() operation. For this
         #  reason this program contains more while loops than
         #  the corresponding Java program.


#  The main program begins.

thread_to_show_seconds  =  ThreadToShowSeconds()

thread_to_show_full_time_info  =  ThreadToShowFullTimeInfo()

print( "\n Press the Enter key to stop the clock." )

thread_to_show_full_time_info.start()

thread_to_show_seconds.start()

any_string_from_keyboard  =  input()

thread_to_show_seconds.stop_this_thread()
thread_to_show_full_time_info.stop_this_thread()




